/**
* DevExtreme (ui/file_manager/file_provider/file_provider.d.ts)
* Version: 19.2.7 (build 20092-0323)
* Build date: Wed Apr 01 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import '../../../jquery_augmentation';

/** Warning! This type is used for internal purposes. Do not import it directly. */
export interface FileProviderOptions<T = FileProvider> {
   /** Specifies which data field provides timestamps that indicate when a file was last modified. */
    dateModifiedExpr?: string | Function;
   /** Specifies which data field provides information about whether a file system item is a directory. */
    isDirectoryExpr?: string | Function;
   /** Specifies the data field that provides keys. */
    keyExpr?: string | Function;
   /** Specifies which data field provides file and directory names. */
    nameExpr?: string | Function;
   /** Specifies which data field provides file sizes. */
    sizeExpr?: string | Function;
   /** Specifies which data field provides icons to be used as thumbnails. */
    thumbnailExpr?: string | Function;
}
/** Warning! This type is used for internal purposes. Do not import it directly. *//** Contains base provider settings. */
export default class FileProvider {
    constructor(options?: FileProviderOptions)
   /** Gets the specified items' content. */
    getItemContent(items: Array<any>): Promise<any> & JQueryPromise<any>;
}
